*====================================================================
* Dies ist eine Prozedur fr Include-Dateien (Ja, sowas geht hier 
* auch <g>), um Fehlermeldungen auszugeben.
*
* Parameter:
*
*   ___ERRMSG Enthlt die Fehlermeldung, die ausgegeben werden soll.
*
*====================================================================

	*-----------------------------------------------------------------
	* Es mu eine Fehlermeldung bergeben werden. Andernfalls gibt es
	* eine Dialogbox, denn nur wenn die Headerdateien gendert worden
	* sind, kann dieser Fall nur eintreten.
	*-----------------------------------------------------------------
	#IFNDEF ___ERRMSG
		#DEFINE ccLOCAL_ACO_ERR_COND MessageBox( ;
			"Error in Include File: No parameter passed to Aco_Err", ;
			MB_OK + MB_ICONSTOP + MB_DEFBUTTON1, ;
			"ActiveDebugging" ;
		) == 0
	#ELSE
		#DEFINE ccLOCAL_ACO_ERR_COND .F.
	#ENDIF
	#IF ccLOCAL_ACO_ERR_COND
	#ENDIF
	#UNDEF ccLOCAL_ACO_ERR_COND
		
	*-----------------------------------------------------------------
	* Als erstes sicherstellen, da es diese Konstante gibt, die de-
	* finiert, ob Fehlermeldungen ausgegeben werden sollen.
	*-----------------------------------------------------------------
	#IFNDEF __INCLUDEERRORS
		#DEFINE __INCLUDEERRORS .T.
	#ENDIF
	
	*-----------------------------------------------------------------
	* Wenn keine optionale Fehlerdatei spezifiziert wurde, diese de-
	* aktivieren. Auerdem deaktivieren wir sie in VFP 5, weil dort
	* die notwendige Funktion STRTOFILE() nicht existiert.
	*-----------------------------------------------------------------
	#IFNDEF __ERRORLOG
		#DEFINE __ERRORLOG 
	#ENDIF
	#IF __VFP5
		#UNDEF __ERRORLOG
		#DEFINE __ERRORLOG 
	#ENDIF
	
	*-----------------------------------------------------------------
	* Es sollen keine Fehlermeldungen ausgegeben werden.
	*-----------------------------------------------------------------
	#IF not __INCLUDEERRORS
		#DEFINE ccLOCAL_ACO_ERR_LOG .F.
	
	*-----------------------------------------------------------------
	* Es sollen Fehlermeldungen in das normale Visual FoxPro Fehler-
	* protokoll geschrieben werden. Das funktioniert nicht, wenn die
	* Datzei nicht ber den Befehl #INCLUDE inkludiert wurde.
	*-----------------------------------------------------------------
	#ELIF Empty([__ERRORLOG])
		#DEFINE ccLOCAL_ACO_ERR_SHOW #DEFINE-Error: ___ERRMSG
		ccLOCAL_ACO_ERR_SHOW
		#UNDEF ccLOCAL_ACO_ERR_SHOW
		#DEFINE ccLOCAL_ACO_ERR_LOG .F.
	
	*-----------------------------------------------------------------
	* Andernfalls die Fehlermeldung in eine Datei schreiben. Da wir
	* verschachtelte IF's brauchen, mssen wir dies ber eine 
	* Konstante sicherstellen. Verschachtelte IF's sind in Header-
	* Dateien nur mglich, wenn die IF Bedingungen immer gltig sind.
	* Bedingungen, die Aktionen auslsen, knnen daher nicht ver-
	* wendet werden.
	*-----------------------------------------------------------------
	#ELSE
		#DEFINE ccLOCAL_ACO_ERR_LOG .T.
	#ENDIF
	
	#DEFINE ccTest Empty([__ERRORLOG])
	
	*-----------------------------------------------------------------
	* Das Error-Log lschen, falls dies der erste Versuch ist. Das
	* machen wir allerdings nur, wenn SET SAFETY OFF ist, denn andern-
	* falls wrde der Anwender fr jede Klasse eine Dialogbox 
	* bekommen.
	*-----------------------------------------------------------------
	#DEFINE ccLOCAL_ACO_ERR_COND .F.
	#IF ccLOCAL_ACO_ERR_LOG
		#IFNDEF __ERRORLOG_STARTED
			#IF Set("Safety") == "OFF"
				#UNDEF ccLOCAL_ACO_ERR_COND
				#DEFINE ccLOCAL_ACO_ERR_COND StrToFile( ;
					"ErrorLog (" + TToC(DateTime()) + ")" + ;
					Chr(13) + Chr(10) + Chr(13) + Chr(10), ;
					[__ERRORLOG] ;
				)==0
			#ENDIF
			#DEFINE __ERRORLOG_STARTED
		#ENDIF
	#ENDIF
	#IF ccLOCAL_ACO_ERR_COND
	#ENDIF
	#UNDEF ccLOCAL_ACO_ERR_COND
	
	*-----------------------------------------------------------------
	* Falls ein Eintrag im Error-Log gemacht werden soll, diesen
	* nun eintragen.
	*-----------------------------------------------------------------
	#IF ccLOCAL_ACO_ERR_LOG
		#DEFINE ccLOCAL_ACO_ERR_COND StrToFile( ;
			"LineNo #" + Alltrim(Str(Line())) + ": " + ;
			[___ERRMSG] + Chr(13) + Chr(10), ;
			[__ERRORLOG], ;
			.T. ;
		) == 0
	#ELSE
		#DEFINE ccLOCAL_ACO_ERR_COND .F.
	#ENDIF
	#IF ccLOCAL_ACO_ERR_COND
	#ENDIF
	#UNDEF ccLOCAL_ACO_ERR_COND
	
	*-----------------------------------------------------------------
	* Und Aufrumen... ___ERRMSG geben wir frei, damit die aufrufende
	* Routine diesen Parameter wieder verwenden kann.
	*-----------------------------------------------------------------
	#UNDEF ccLOCAL_ACO_ERR_LOG
	#UNDEF ___ERRMSG
	
